angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope){

})

.controller('LoginCtrl', function($scope, $state, $http, laconfig, User, $ionicLoading){
	$scope.login = {};
	$scope.submitForm = function() {
		$http({
			method: 'POST',
			url: laconfig.backend + 'biLogin.json',
			data : {
				email : $scope.login.email,
				password: $scope.login.pass
			}
		})
		.success(function(data){
			data.Players._id = data.Players.id;
			//guardar en db
			User.saveUser(data.Players).then(function(){
				$state.go('tab.characters.carrusel');
			}).catch(function(err){
				console.log('login error:', err);
				$scope.login.servererror = true;
			});
		})
		.error(function(data){
			console.log('response error:', data);
			$scope.login.servererror = true;
		})
	};

	$scope.fbIngresa = function(){
		var apidata = {};
		$ionicLoading.show({
			content: 'Loading',
			animation: 'fade-in',
			showBackdrop: true,
			maxWidth: 200,
			showDelay: 0
		});
		User.checkAndConnectFb().then(function(response){
			apidata.facebook_id	= response.id
			if(angular.isDefined(response.email)){
				apidata.email = response.email;
			}
			if(angular.isDefined(response.name)){
				apidata.fullname = response.name;
			}else{
				var fullname = response.first_name;
				if(angular.isDefined(response.middle_name)){
					fullname = fullname + " " + response.middle_name;
				}
				if(angular.isDefined(response.last_name)){
					fullname = fullname + " " + response.last_name;
				}
				apidata.fullname = fullname;
			}
			console.log('Los datos a enviar', apidata);
			$http({
				method: 'POST',
				url: laconfig.backend + 'biLogin.json',
				data : apidata
			})
			.success(function(data){
				data.Players._id = data.Players.id;
				//guardar en db
				User.saveUser(data.Players).then(function(){
					$state.go('tab.characters.carrusel');
					$ionicLoading.hide();
				}).catch(function(err){
					console.log('login error:', err);
					$scope.login.servererror = true;
					$ionicLoading.hide();
				});
			})
			.error(function(data){
				console.log('response error:', data);
				$scope.login.servererror = true;
				$ionicLoading.hide();
			})
		}).catch(function(err){
			console.log(err);
			$ionicLoading.hide();
		}).finally(function(){
			console.log('finally');
		});
	};
	$scope.skipRegister = function(){
		console.log('asdf');
		$ionicLoading.show({
			content: 'Loading',
			animation: 'fade-in',
			showBackdrop: true,
			maxWidth: 200,
			showDelay: 0
		});
		User.anonLogin().then(function(data){
			console.log('anonLogin success', data);
			data.Players._id = data.Players.id;
			//guardar en db
			User.saveUser(data.Players).then(function(){
				$state.go('tab.characters.carrusel');
				$ionicLoading.hide();
			}).catch(function(err){
				console.log('login error:', err);
				$scope.login.servererror = true;
				$ionicLoading.hide();
			});
		}).catch(function(err){
			console.log('anonLogin error', err);
			$ionicLoading.hide();
		});
	}
})

.controller('RegisterCtrl', function($scope, $state, $http, laconfig, User){
	$scope.register = {};
	$scope.submitForm = function() {
        $http({
            method: 'POST',
			url: laconfig.backend + 'biLogin.json',
            data : {
                nombre : $scope.register.nombre,
                email : $scope.register.email,
                password: $scope.register.pass
            }
        })
        .success(function(data){
            console.log('response success:', data);
			User.saveUser(data.Players).then(function(){
	            $state.go('tab.characters.carrusel');
			}).catch(function(err){
				console.log('login error:', err);
				$scope.login.servererror = true;
			});
        })
        .error(function(data){
            console.log('response error:', data);
        })
	};
})

.controller('MapCtrl', function($scope, $stateParams, DB, User, Subject, Utils, Question, Round, User){
	var lamateria = $stateParams.materia;
	$scope.ladata = $stateParams;
	$scope.Usuario = {};
	$scope.cargaPreguntas = false;
	User.getUser().then(function(datos){
		$scope.Usuario = datos;
	});
	Round.initComodines();
	DB.subject.get(lamateria).then(function(materiadata){
		$scope.materiadata = materiadata;
		Question.initRound(materiadata).then(function(question){
			console.log('Pregunta random:', question);
			$scope.lapregunta = question;
		}).catch(function(err){
			console.log('error en initRound mapctrl:', err);
		}).finally(function(response){
			$scope.cargaPreguntas = true;
		});;

	}).catch(function(err){
		console.log('Error en DB.subject.get($stateparams.materia):', err);
	});
})

.controller('VsCtrl', function($scope, DB, $stateParams, Challenge, Question, User, Round){
	$scope.desafio = $scope.Usuario = $scope.laPregunta = {};
	$scope.cargaPreguntas = false;
	User.getUser().then(function(datos){
		$scope.Usuario = datos;
		Challenge.getChallenge($stateParams.challengeid).then(function(result){
			$scope.desafio = result.Challenge;
			var preguntas = [];

			console.log('getChallenge', result.Challenge.Questions);
			Round.initComodines();
			angular.forEach(result.Challenge.Questions, function(aidi, key){
				preguntas.push(aidi.question_id);
			});
			console.log('preguntas', preguntas);
			Question.initChallenge(preguntas).then(function(question){
				console.log(question);
				$scope.laPregunta = question;
				$scope.cargaPreguntas = true;
			}).catch(function(err){
				console.log('error initChallenge VsCtrl', err);
			});
		}).catch(function(err){
			console.log('error getChallenge VsCtrl', err);
		});
	}).catch(function(err){
		console.log('error getUser VsCtrl', err);
	});
})

.controller('RoundCtrl', function($scope, $rootScope, $stateParams, $ionicNavBarDelegate, $ionicLoading, laconfig, DB, Round, localStorageService){
	$scope.opcionesPregunta 	= [];
	$scope.comodinUsado			= [];
	$scope.comodinUsado.agranda = localStorageService.get('agranda');
	$scope.comodinUsado.tiempo	= localStorageService.get('tiempo');
	$scope.comodinUsado.saltar	= localStorageService.get('saltar');
	$scope.roundTitle = '';
	$scope.roundNumber = '';
	$scope.roundStage = '';
	$scope.challengeid = $stateParams.challengeid || null;
	$scope.preguntaGuardada = false;

	$scope.$on('toggleComodines', function(e, valor){
		console.log('el valor toggleComodines:', valor);
		$scope.showComodines = valor;
	});

	$rootScope.$on('resetComodines', function(){
		console.log('Reseteo de comodines');
		$scope.comodinUsado.agranda = localStorageService.get('agranda');
		$scope.comodinUsado.tiempo	= localStorageService.get('tiempo');
		$scope.comodinUsado.saltar	= localStorageService.get('saltar');
	});

	console.log('Parametros de Estado', $stateParams);
	$scope.$on('lapregunta', function(e, pregunta){
		$scope.pregunta = pregunta;
		$scope.pregunta.roundrelativo = pregunta.round - ((pregunta.stage-1) * 15);
		$scope.preguntaGuardada = false;
		DB.subject.get(pregunta.category.toLowerCase()).then(function(materiadata){
			$scope.roundTitle = materiadata.name;
		}).catch(function(err){
			console.log('Error en DB.subject.get($stateparams.materia):', err);
		});
	});
	$scope.$on('pintalaWea', function(){
		console.log('Llego al emit en round');
		angular.forEach($scope.pregunta.Options, function(alternativa, llave){
			if(alternativa.is_correct == true){
				console.log('Esta es correcta', alternativa);
				$scope.pregunta.Options[llave].isSelected = true;
				$scope.$broadcast('saveCorrectas', alternativa.id);
				$scope.$broadcast('saveSeleccionadas', alternativa.id);
			}
		})
	})

	$scope.$on('saltaLaPregunta', function(){
		$scope.$broadcast('saltarLaPregunta');
	})

	$scope.$on('addCDSeconds', function(){
		$scope.$broadcast('timer-add-cd-seconds', 30);
	})

	$ionicNavBarDelegate.showBar(false);

	$scope.$on('initTimer', function(){
		console.log('initTimer');
		$scope.$broadcast('timer-start');
	});

	$scope.timerDone = function(){
		console.log('stateParams', $stateParams);
		if($scope.challengeid){
			Round.finishChallenge($scope.challengeid, 'perdedor');
		} else {
			Round.defeat(false, $stateParams.materia, $stateParams.elstage, $stateParams.elround, 'timeout');
		}
	}



	$scope.guardarPregunta = function(idPregunta){
		Round.guardaPregunta(idPregunta).then(function(response){
			$scope.preguntaGuardada = true;
			$scope.showComodines = false;

			if(response.data.exito == 1){
				$ionicLoading.show({
					template: 'Pregunta guardada',
					noBackdrop: true,
					duration: 1000
				});
			} else if(response.data.existente){
				$ionicLoading.show({
					template: 'Ya tenías guardada esta pregunta',
					noBackdrop: true,
					duration: 2000
				});
			} else if(response.data.limite){
				$ionicLoading.show({
					template: 'Ya tienes las 10 preguntas necesarias, ¡Desafía a tu amigo!',
					noBackdrop: true,
					duration: 2000
				});
			}
		}).catch(function(err){
			console.log(err);
		});
	}
})

.controller('QuestionCtrl', function($sce, $scope, $rootScope, $q, $stateParams, $ionicNavBarDelegate, $ionicActionSheet, $timeout, Round, Question, Utils){
	$ionicNavBarDelegate.showBar(false);

	var seleccionadas = [],
		correctas = [];

	$scope.$emit('initTimer');

	Question.getQuestion($stateParams.laquestion).then(function(pregunta){
		$scope.pregunta = pregunta;
		$scope.pregunta.question = pregunta.question.replace(/[&]nbsp[;]/gi,'');
		$scope.$emit('lapregunta', $scope.pregunta);
		//Complete_box
		if($scope.pregunta.type == 'COMPLETE_BOX'){
			angular.forEach(pregunta.Options, function(estaopcion, key){
				var tempExtras = [];
				angular.forEach(angular.fromJson(estaopcion.extra), function(extra){
					angular.forEach(extra, function(key, value){
						tempExtras.push({
							valid: value,
							text : key + ' <i class="icon ion-ios-circle-outline"></i>',
							seleccionada: false,
							valor: key
						});
					});
				});
				$scope.pregunta.Options[key].parsedExtras = tempExtras;
			});
			$scope.muestraExtras = function(esta){
				$ionicActionSheet.show({
					buttons: esta.parsedExtras,
					titleText: 'Opción para:' + '<br /><b>' + esta.option + '</b>',
					cancelText: 'Cerrar',
					cancel: function() {
					},
					destructiveText: 'Limpiar',
					destructiveButtonClicked: function(index){
						esta.seleccionada = false;
						var i;
						for(i=0; i< esta.parsedExtras.length; i++){
							esta.parsedExtras[i].seleccionada = false;
							esta.parsedExtras[i].text = esta.parsedExtras[i].valor + ' <i class="icon ion-ios-circle-outline"></i>';
						}
						return true;
					},
					buttonClicked: function(index, elobj){
						if(esta.parsedExtras[index].seleccionada){
							esta.parsedExtras[index].seleccionada = false;
							esta.seleccionada = false;
							esta.parsedExtras[index].text = esta.parsedExtras[index].valor + ' <i class="icon ion-ios-circle-outline"></i>';
						}else{
							var i;
							for(i=0; i< esta.parsedExtras.length; i++){
								esta.parsedExtras[i].seleccionada = false;
								esta.parsedExtras[i].text = esta.parsedExtras[i].valor + ' <i class="icon ion-ios-circle-outline"></i>';
							}
							esta.seleccionada = esta.parsedExtras[index].valor;
							esta.parsedExtras[index].seleccionada = true;
							esta.parsedExtras[index].text = '<span class="balanced">'+ esta.parsedExtras[index].valor + ' <i class="icon ion-ios-circle-filled"></i></span>';
						}
						return true;
					}
				});
			}
		}else if($scope.pregunta.type == 'TF_SIMPLE' || $scope.pregunta.type == 'TF_MULTIPLE'){
			angular.forEach($scope.pregunta.Options, function(value, key){
				$scope.pregunta.Options[key].seleccionada = "";
				$scope.pregunta.Options[key].correcta = "";
				if(value.is_correct){
					$scope.pregunta.Options[key].correcta = "verdadera";
				}else{
					$scope.pregunta.Options[key].correcta = "falsa";
				}
			});
			$scope.toggleSelectedToF = function(estaotra, clickeada){
				estaotra.seleccionada = clickeada;
			}
		}else if($scope.pregunta.type == 'FIB'){
			var extras = [];
			var opcionesExtras = [];
			var preguntaArreglada = '';
			angular.forEach($scope.pregunta.Options, function(value, key){
				if (extras.indexOf(value.option) == -1) {
					extras.push(value.option);
					opcionesExtras.push({
						text : value.option + ' <i class="icon ion-ios-circle-outline"></i>',
						seleccionada: false,
						valor: value.option
					});;
				}
			});
			var fosforos = $scope.pregunta.question.match(/\[\[(.+?)\]\]/g);
			var opcionesPregunta = [];

			angular.forEach(fosforos, function(value, key){
				elemento = value.replace(/\[\[(.+?)\]\]/g, "$1");
				opcionesPregunta.push({
					seleccionada: '',
					correcta: elemento,
					selected: false
				});
			});
			angular.forEach(fosforos, function(valor, llave){
				var temp = '';
				temp = $scope.pregunta.question.replace(/\[\[(.+?)\]\]/, "<button class='alternativa fib-option' data-cual='$1' ng-click='muestraExtras("+llave+")' >&nbsp;{{pregunta.opcionesPregunta["+llave+"].seleccionada}}&nbsp;</button>");
				$scope.pregunta.question = temp;
			});

			$scope.pregunta.opcionesPregunta = opcionesPregunta;
			$scope.muestraExtras = function(posicion){
				$ionicActionSheet.show({
					buttons: opcionesExtras,
					titleText: 'Seleccione la alternativa correcta',
					cancelText: 'Cerrar',
					cancel: function() {
					},
					destructiveText: 'Limpiar',
					destructiveButtonClicked: function(index){
						for(i=0; i< opcionesExtras.length; i++){
							opcionesExtras[i].seleccionada = false;
							$scope.pregunta.opcionesPregunta[posicion].seleccionada = '';
						}
						return true;
					},
					buttonClicked: function(index, elobj){
						var i;
						for(i=0; i< opcionesExtras.length; i++){
							opcionesExtras[i].seleccionada = false;
						}
						$scope.pregunta.opcionesPregunta[posicion].seleccionada = elobj.valor;
						if(elobj.seleccionada == true){
							elobj.seleccionada = false;
						}else{
							elobj.seleccionada = true;
						}
						console.log("La posicion", posicion, index, elobj);
						return true;
					}
				});
			};

		};

	}).catch(function(err){
		console.log('getQuestion en QuestionCtrl error:', err);
	});

	//multiple _

	$scope.getCorrectas = function(){
		var res = $q.defer(),
			grupoBuenas = [];
		switch($scope.pregunta.type) {
			default:
				angular.forEach($scope.pregunta.Options, function(alternativa){
					if(alternativa.is_correct){
						grupoBuenas.push(alternativa.id);
					}
					res.resolve(grupoBuenas);
				});
		}


		return res.promise;
	}

	$scope.$on('saveCorrectas', function(e,cual){
		correctas.push(cual);
		console.log('correctas:',correctas);
	});

	$scope.$on('removeCorrectas', function(e, cual){
		var indice = correctas.indexOf(cual);
		if(indice > -1){
			correctas.splice(indice, 1);
		}
		console.log(correctas);
	});

	$scope.$on('saveSeleccionadas', function(e, cual){
		seleccionadas.push(cual);
		console.log(seleccionadas);
	});

	$scope.$on('removeSeleccionadas', function(e, cual){
		var indice = seleccionadas.indexOf(cual);
		if(indice > -1){
			seleccionadas.splice(indice, 1);
		}
		console.log(seleccionadas);
	});

	$scope.$on('saltarLaPregunta', function(){
		console.log('Llego al emit en round');
		Question.nextQuestion($stateParams.laquestion, $scope.challengeid);
	})
	$scope.checkQuestion = function(){
		var res = $q.defer();
		$scope.getCorrectas().then(function(buenas){
			console.log('asdf',buenas);
			var correcta = true;
			angular.forEach(seleccionadas, function(seleccionada){
				if(correcta == true){
					console.log('foreach', seleccionada);
					console.log('ok?', buenas.indexOf(seleccionada));
					if(buenas.indexOf(seleccionada) == -1){
						console.log('NOOOOO');
						correcta = false;
					};
				}
				console.log('¿está buena?', correcta);
				res.resolve(correcta);
			});
		}).catch(function(err){
			res.reject(err);
		});
		return res.promise;
	}

	$scope.listoCompleteBox = function(){
		var correctas = 0;
		var incorrectas = 0;
		var seleccionadas = 0;
		var totales = $scope.pregunta.Options.length;
		angular.forEach($scope.pregunta.Options, function(opcion, llave){
			angular.forEach(opcion.parsedExtras,  function(value, key){
				if(value.seleccionada){
					seleccionadas++;
					if(value.valid == 'OK'){
						correctas++;
					}else{
						incorrectas++;
					}
				}
			});
		});
		if(seleccionadas == totales){
			if((correctas == totales) && (incorrectas == 0)){
				Question.nextQuestion($stateParams.laquestion, $scope.challengeid);
			}else{
				if($scope.challengeid){
					Round.finishChallenge($scope.challengeid, 'perdedor');
				} else {
					Round.defeat(false, $stateParams.materia, $stateParams.elstage, $stateParams.elround, 'defeat');
				}
			}
		}
	}

	$scope.listoMultipleChoice = function(){
		$scope.checkQuestion().then(function(respuesta){
			console.log('respuesta:', respuesta);
			if(!respuesta){
				if($scope.challengeid){
					Round.finishChallenge($scope.challengeid, 'perdedor');
				} else {
					Round.defeat(false, $stateParams.materia, $stateParams.elstage, $stateParams.elround, 'defeat');
				}
			} else {
				Question.nextQuestion($stateParams.laquestion, $scope.challengeid);
			}
		}).catch(function(err){
			console.log('error en listoClick:', err);
		});
	}

	$scope.listoTrueOrFalse = function(){
		var correctas = 0;
		var totales = $scope.pregunta.Options.length;
		var seleccionadas = 0;
		angular.forEach($scope.pregunta.Options, function(opcion, llave){
			console.log('La Opcion', opcion);
			if(opcion.seleccionada != ''){
				seleccionadas++;
				if(opcion.seleccionada == opcion.correcta){
					correctas++;
				}
			}
		});
		if(seleccionadas == totales){
			if((correctas == totales)){
				Question.nextQuestion($stateParams.laquestion, $scope.challengeid);
			}else{
				if($scope.challengeid){
					Round.finishChallenge($scope.challengeid, 'perdedor');
				} else {
					Round.defeat(false, $stateParams.materia, $stateParams.elstage, $stateParams.elround, 'defeat');
				}
			}
		}
	}

	$scope.listoFib = function(){
		var correctas = 0;
		var totales = $scope.pregunta.opcionesPregunta.length;
		var seleccionadas = 0;
		angular.forEach($scope.pregunta.opcionesPregunta, function(opcion, llave){
			if(opcion.seleccionada != ''){
				seleccionadas++;
				if(opcion.seleccionada == opcion.correcta){
					correctas++;
				}
			}
		});
		if(seleccionadas == totales){
			if((correctas == totales)){
				Question.nextQuestion($stateParams.laquestion, $scope.challengeid);
			}else{
				if($scope.challengeid){
					Round.finishChallenge($scope.challengeid, 'perdedor');
				} else {
					Round.defeat(false, $stateParams.materia, $stateParams.elstage, $stateParams.elround, 'defeat');
				}
			}
		}
	}
	//servicio que te lleva a otra pregunta, o que te deja en error.
})

.controller('TimerCtrl', function($scope){
	$scope.segundos = 420;
	$scope.$broadcast('timer-reset');
})

.controller('ChallengeFinishedCtrl', function($scope, $stateParams){
	$scope.ladata = $stateParams;
	if($scope.ladata.result == 'perdedor'){
		$scope.ladata.titulo = '¡Perdiste el desafío!';
		$scope.ladata.contenido = 'Se llevaron tus puntos :(';
	}
	if($scope.ladata.result == 'ganador'){
		$scope.ladata.titulo = '¡Ganaste el desafío!';
		$scope.ladata.contenido = 'Ganaste 100 puntos';
	}
})

.controller('FinishedCtrl', function($scope, $stateParams, Round){
	$scope.ladata = $stateParams;
	console.log($stateParams);
	if($scope.ladata.type == 'timeout'){
		$scope.ladata.titulo = '¡Te quedaste sin tiempo!';
		$scope.ladata.contenido = 'Te demoraste mucho, recuerda que sólo tienes 7 Minutos por cada ronda';
		$scope.ladata.expresion = 'mal';
	} else if($scope.ladata.type == 'defeat'){
		$scope.ladata.titulo = '¡Te Equivocaste!';
		$scope.ladata.contenido = 'La respuesta estaba incorrecta';
		$scope.ladata.expresion = 'mal';
	} else if($scope.ladata.type == 'nolives'){
		$scope.ladata.titulo = '¡No te quedan vidas!';
		$scope.ladata.contenido = 'Comparte o espera 5 minutos';
		$scope.ladata.expresion = 'mal';
	} else if($scope.ladata.type == 'victory'){
		$scope.ladata.titulo = '¡Al fin!';
		$scope.ladata.contenido = 'Pasaste la ronda';
		$scope.ladata.expresion = 'bien';
	} else if($scope.ladata.type == 'finishstage'){
		$scope.ladata.titulo = '¡Terminaste!';
		$scope.ladata.contenido = 'Pasaste la ronda. Ya no tienes más preguntas, pronto lanzaremos la etapa 2.';
		$scope.ladata.expresion = 'bien';
		$scope.ladata.removecontinue = true;
	} else if($scope.ladata.type == 'finishgame'){
		$scope.ladata.titulo = '¡Terminaste!';
		$scope.ladata.contenido = 'Felicidades, has terminado la materia.';
		$scope.ladata.expresion = 'bien';
	};

})

.controller('ComodinesCtrl', function($scope, DB, Question, Round){

	$scope.comodin = function(cual){
		var actual = $scope.pregunta;
		switch(cual){
			case 'agranda':
				Round.quemaComodin('agranda').then(function(res){
					Round.returnComodin('agranda').then(function(respuesta){
						console.log(respuesta);
						$scope.comodinUsado.agranda = respuesta;
						$scope.$emit('toggleComodines', false);
					}).catch(function(err){
						console.log('error return comodin', err);
					});
				}).catch(function(err){
					console.log('error return comodin', err);
				});
				if(actual.type == 'MULTIPLE_CHOICE'){
					$scope.$emit('pintalaWea');
					$scope.$emit('toggleComodines', false);

				}else if(actual.type == 'TF_SIMPLE' || actual.type == 'TF_MULTIPLE'){
					angular.forEach(actual.Options, function(value, key){
						value.seleccionada = value.correcta;
					});
					$scope.$emit('toggleComodines', false);

				}else if(actual.type == 'COMPLETE_BOX'){
					angular.forEach(actual.Options, function(value, key){
						angular.forEach(value.parsedExtras, function(val, ky){
							if(val.valid == 'OK'){
								actual.Options[key].parsedExtras[ky].seleccionada = true;
								actual.Options[key].seleccionada = val.valor;
							}
						});
					});
					$scope.$emit('toggleComodines', false);

				}else if(actual.type == 'FIB'){
					angular.forEach(actual.opcionesPregunta, function(valor, llave){
						actual.opcionesPregunta[llave].seleccionada = valor.correcta;
					});
					$scope.$emit('toggleComodines', false);

				}
				break;
			case 'saltar':
				Round.quemaComodin('saltar').then(function(res){
					Round.returnComodin('saltar').then(function(respuesta){
						console.log(respuesta);
						$scope.comodinUsado.saltar = respuesta;
					}).catch(function(err){
						console.log('error return comodin', err);
					});
				}).catch(function(err){
					console.log('error return comodin', err);
				});
				$scope.$emit('saltaLaPregunta');
				$scope.$emit('toggleComodines', false);

				break;
			case 'tiempo':
				Round.quemaComodin('tiempo').then(function(res){
					Round.returnComodin('tiempo').then(function(respuesta){
						console.log(respuesta);
						$scope.comodinUsado.tiempo = respuesta;
					}).catch(function(err){
						console.log('error return comodin', err);
					});
					$scope.$emit('toggleComodines', false);

				}).catch(function(err){
					console.log('error return comodin', err);
				});
				$scope.$emit('addCDSeconds');
				break;


		}
	}
})

.controller('ProfileCtrl', function($scope, DB, User, $ionicNavBarDelegate, $timeout, $ionicLoading){
	$scope.$on('$ionicView.beforeEnter', function(){
		$ionicLoading.show({
			content: 'Loading',
			animation: 'fade-in',
			showBackdrop: true,
			maxWidth: 200,
			showDelay: 0
		});
		User.updateUser().then(function(algo){
			User.getUser().then(function(datos){
				$scope.Usuario = datos;
				$ionicNavBarDelegate.title(datos.fullname);
				$scope.numNotifications = 0;
				if(angular.isDefined(datos.StoredQuestion)){
					$scope.numHairyQuestions = datos.StoredQuestion.length;
				}else{
					$scope.numHairyQuestions = 0;
				}
				angular.forEach(datos.Notifications, function(value, key){
					if(value.unread == 1){
						$scope.numNotifications += 1;
					}
				});
			}).catch(function(err){
				console.log('Se pudrio todo', err);
			}).finally(function(){
				$ionicLoading.hide();
			});
		}).catch(function(err){
			console.log('Se pudrio todo', err);
		}).finally(function(){
			$ionicLoading.hide();
		});
	});

	$timeout(function(){
		$ionicLoading.hide();
	}, 4000);

})

.controller('ProfileEditCtrl', function($scope, DB){

})

.controller('NotificationsCtrl', function($scope, DB, User){

})

.controller('NotificationCtrl', function($scope, DB, $stateParams){

})

.controller('ChallengeNotificationCtrl', function($scope, DB, $stateParams, Challenge, User){
	$scope.desafio = {};
	User.getUser().then(function(datos){
		$scope.Usuario = datos;
	});
	Challenge.getChallenge($stateParams.challengeid).then(function(result){
		$scope.desafio = result.Challenge;
		console.log('getChallenge', result);
	});

})

.controller('AchievementsCtrl', function($scope, DB){

})

.controller('HairyQuestionsCtrl', function($scope, $q, DB, Question, User){
	$scope.FilteredQuestions = [];
	$scope.QuestionCount = 0;
	angular.forEach($scope.Usuario.StoredQuestion, function(value, key){
		console.log('Pregunta guardada', value);
		$scope.QuestionCount++;
		Question.getQuestionById(value.question_id).then(function(response){
			var question = {};
			question = response.rows[0].doc;
			DB.subject.get(question.category.toLowerCase()).then(function(response){
				question.categoryHumanAfterAll = response.name;
			}).catch(function(err){
				console.log('Error');
			});
 			$scope.FilteredQuestions.push(question);
			console.log(response);
		}).catch(function(err){console.log('Capturado el error en HairyQuestionsCtrl', err)});
	});
	$scope.getFbFriends	= function(){

	}
})

.controller('RankingCtrl', function($scope, $http, $q, laconfig, DB){
	$scope.rankeados = [];
	$http({
		method: 'GET',
		url: laconfig.backend + 'getTheRanking.json'
	})
	.success(function(response){
		angular.forEach(response.ranking, function(value, key){
			$scope.rankeados.push(value);
		});
		console.log($scope.rankeados);
	}).catch(function(err){
		console.log('Error del ranking', err)
	});
})

.controller('ForgotCtrl', function($scope, $state, $http, laconfig){
	$scope.submitForm = function(){
		$scope.forgot = {};
		$http({
			method: 'POST',
			url: laconfig.backend + 'sendResetPassword.json',
			data: {
				email : $scope.forgot.email
			}
		})
		.success(function(data){
			console.log('response success:', data);
			$state.go('login');
			//todo: poner mensaje global: "Revisa tu email para resetear tu contraseña"
		})
		.error(function(data){
            console.log('response error:', data.msg);
            $scope.forgot.servererror = data.msg || true;
		})
	};
})

.controller('CharactersCtrl', function(DB, $q, $scope, $http, laconfig, localStorageService, User, Subject){

	Subject.activeSubjects().then(function(datos){
		console.log('datos!!!',datos);
		$scope.subjectInfo = datos;
		console.log($scope.subjectInfo);
		DB.subject.allDocs({
			include_docs: true,
			attachments: true
		}).then(function(lasmaterias){
			console.log(lasmaterias);
			$scope.characters = lasmaterias.rows;
		}).catch(function(err){
			console.log('error en CharacterCtrl: ', err);
		})
	}).catch(function(err){
		console.log('error en Subject.activeSubjects:', err);
	});

})
;